DROP ROLE(7)

NAME
DROP_ROLE - remove a database role

SYNOPSIS

DROP ROLE [ IF EXISTS ] name [, ...]

DESCRIPTION

DROP ROLE removes the specified role(s). To drop a superuser role, you must be a superuser yourself; to drop non-superuser roles, you must have CREATEROLE privilege.

A role cannot be removed if it is still referenced in any database of the cluster; an error will be raised if so. Before dropping the role, you must drop all the objects it owns (or reassign their ownership) and revoke any privileges the role has been granted on other objects. The REASSIGN OWNED (REASSIGN_OWNED(7)) and DROP OWNED (DROP_OWNED(7)) commands can be useful for this purpose; see Section 21.4 for more discussion.

However, it is not necessary to remove role memberships involving the role; DROP ROLE automatically revokes any memberships of the target role in other roles, and of other roles in the target role. The other roles are not dropped nor otherwise affected.

PARAMETERS

IF EXISTS
    Do not throw an error if the role does not exist. A notice is issued in this case.

name
    The name of the role to remove.

NOTES

PostgreSQL includes a program dropuser(1) that has the same functionality as this command (in fact, it calls this command) but can be run from the command shell.

EXAMPLES

To drop a role:

    DROP ROLE jonathan;

COMPATIBILITY

The SQL standard defines DROP ROLE, but it allows only one role to be dropped at a time, and it specifies different privilege requirements than PostgreSQL uses.

SEE ALSO
CREATE ROLE (CREATE_ROLE(7)), ALTER ROLE (ALTER_ROLE(7)), SET ROLE (SET_ROLE(7))